#include "node.h"
bool KeywordToken::isReserved(string s){
  static const vector<string> reserved
    {
     "abs",
     "all",
     "ancestor",
     "and",
     "any",
     "anydirection",
     "arrow",
     "ascii",
     "assert",
     "attack",
     "attacked",
     "attackedby",
     "attacks",
     "atomic",
     "between",
     "black",
     "btm",
     "by",
     "capture",
     "captures",
     "castle",
     "check",
     "child",
     "cql",
     "cql_abort",
     "cql_assertvariations",
     "cql_hhdbhascook",
     "colortype",
     "comment",
     "connectedpawns",
     "consecutivemoves",
     "count",
     "countmoves",
     "currentmove",
     "currentposition",
     "curpos",
     "currenttransform",
     "dark",
     "date",
     "depth",
     "descendant",
     "diagonal",
     "dictionary",
     "dihedral",
     "distance",
     "doubledpawns",
     "down",
     "echo",
     "eco",
     "elo",
     "else",
     "enpassant",
     "enpassantsquare",
     "equal",
     "event",
     "eventdate",
     "extension",
     "false",
     "fen",
     "file",
     "find",
     "firstmatch",
     "flip",
     "flipcolor",
     "flipdihedral",
     "fliphorizontal",
     "flipvertical",
     "focus",
     "from",
     "function",
     "gamenumber",
     "hascomment",
     "hhdb",
     "horizontal",
     "idealmate",
     "idealstalemate",
     "if",
     "in",
     "indexof",
     "initial",
     "initialposition",
     "input",
     "int",
     "isbound",
     "isolatedpawns",
     "isunbound",
     "keepallbest",
     "lastgamenumber",
     "lastposition",
     "lca",
     "left",
     "legal",
     "light",
     "line",
     "local",
     "loop",
     "lowercase",
     "maindiagonal",
     "mainline",
     "makesquare",
     "matchcount",
     "matchstring",
     "mate",
     "max",
     "message",
     "min",
     "modelmate",
     "modelstalemate",
     "move",
     "movenumber",
     "nestban",
     "northeast",
     "northwest",
     "nosort",
     "not",
     "notransform",
     "null",
     "nullmove",
     "o-o",
     "o-o-o",
     "offdiagonal",
     "oldline",
     "or",
     "originalcomment",
     "orthogonal",
     "output",
     "parent",
     "passedpawns",
     "path",
     "pathcount",
     "pathcountunfocused",
     "pathdebug",
     "pathlastposition",
     "pathstart",
     "persistent",
     "pgn",
     "piece",
     "pieceid",
     "piecepath",
     "piecename",
     "pin",
     "player",
     "ply",
     "position",
     "positionid",
     "power",
     "previous",
     "primary",
     "promote",
     "pseudolegal",
     "puremate",
     "purestalemate",
     "quiet",
     "rank",
     "ray",
     "readfile",
     "removecomment",
     "result",
     "reversecolor",
     "right",
     "rotate45",
     "rotate90",
     "secondary",
     "settag",
     "shift",
     "shifthorizontal",
     "shiftvertical",
     "sidetomove",
     "silent",
     "similarposition",
     "singlecolor",
     "site",
     "sort",
     "sqrt",
     "southeast",
     "southwest",
     "square",
     "stalemate",
     "str",
     "string",
     "substring",
     "tag",
     "terminal",
     "then",
     "through",
     "title",
     "to",
     "transform",
     "true",
     "try",
     "type",
     "typename",
     "unbind",
     "up",
     "uppercase",
     "variation",
     "variations",
     "verbose",
     "vertical",
     "virtualmainline",
     "while",
     "white",
     "writefile",
     "wtm",
     "xray",
     "year",
     "."
    };
  
  for(auto keyword : reserved)
    if(keyword==s) return true;
  return false;
}

KeywordToken::KeywordToken(string x):StringToken(x){
  uassert(isReserved(x),"Cannot create keyword from unreserved name: ",x.c_str());
}

